package eu.mhsl.minecraft.pixelblocks.listeners;

import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.inventory.*;
import org.bukkit.inventory.CraftingInventory;
import org.bukkit.inventory.PlayerInventory;

public class InventoryListener implements Listener {
    @EventHandler
    static void onInventoryOpen(InventoryOpenEvent event) {
        if(CommonEventHandlers.isInPixelWorld(event.getPlayer().getWorld())) {
            if(!(event.getInventory() instanceof PlayerInventory) && !(event.getInventory() instanceof CraftingInventory)) {
                event.setCancelled(true);
            }
        }
    }

    @EventHandler
    static void onInventoryDrag(InventoryDragEvent event) {
        if(CommonEventHandlers.isInPixelWorld(event.getWhoClicked().getWorld())) {
            if(!(event.getInventory() instanceof PlayerInventory) && !(event.getInventory() instanceof CraftingInventory)) {
                event.setCancelled(true);
            }
        }
    }

    @EventHandler
    static void onInventoryClick(InventoryClickEvent event) {
        if(CommonEventHandlers.isInPixelWorld(event.getWhoClicked().getWorld())) {
            if(!(event.getInventory() instanceof PlayerInventory) && !(event.getInventory() instanceof CraftingInventory)) {
                event.setCancelled(true);
            }
        }
    }

    @EventHandler
    static void onInventoryInteract(InventoryInteractEvent event) {
        if(CommonEventHandlers.isInPixelWorld(event.getWhoClicked().getWorld())) {
            if(!(event.getInventory() instanceof PlayerInventory) && !(event.getInventory() instanceof CraftingInventory)) {
                event.setCancelled(true);
            }
        }
    }

    @EventHandler
    static void onInventoryPickupItem(InventoryPickupItemEvent event) {
        if(CommonEventHandlers.isInPixelWorld(event.getItem().getWorld())
            && event.getInventory().getType() == InventoryType.HOPPER) {
            event.setCancelled(true);
        }
    }
}
